//
//  MainViewController.m
//  LinkRouter
//
//  Created by USRCN on 14-7-4.
//  Copyright (c) 2014年 usrcn. All rights reserved.
//

#import "MainViewController.h"
#import "GCDAsyncUdpSocket.h"
#import "SSIDListViewController.h"
#import "MBProgressHUD.h"

@interface MainViewController (){
    NSString *port ;
}

@end

@implementation MainViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
//    [self.getSSIDBtn setTitle:NSLocalizedString(@"getssidBtn", nil) forState:UIControlStateNormal];
    port = [[NSUserDefaults standardUserDefaults] objectForKey:@"port"];
    if (port == nil) {
        port = @"1902";
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated{
    [[UdpHandler defaultUDP]setDelegate:self];
    
}

- (IBAction)beginBtnPressed:(id)sender {
    
    
//    NSString *port = self.pottLb.text;
//    if ([self isStrEmpty:port]) {
//        [self shakeAction:self.pottLb];
//        return;
//    }
    
    [UdpHandler defaultUDP].targetPort  = [port intValue];
    
    
    if (self.ssidTF.text.length == 0) {
        
//        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"alert" message:NSLocalizedString(@"fillSSID", nil) delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
//        [alert show];
        
        [self shakeAction:self.ssidTF];
        
        return;
    }
    NSData *ssiddata = [self.ssidTF.text dataUsingEncoding:NSUTF8StringEncoding];
    NSData *pwdata = [self.pwdTF.text dataUsingEncoding:NSUTF8StringEncoding];
    int len = 1 + 1 + ssiddata.length + 2 + pwdata.length;
    Byte b = 0xff;
    NSMutableData *data = [[NSMutableData alloc]initWithBytes:&b length:1];
    Byte b0 = 0x00;
    [data appendBytes:&b0 length:1];
    [data appendBytes:&len length:1];// 长度
    
    Byte bb[] = {0x02,0x00}; // 命令字 ssid-index
    [data appendBytes:bb length:2];
    
    [data appendData:ssiddata]; // ssid
    
    Byte tag[] = {0x0d,0x0a}; // 结束标记
    [data appendBytes:tag length:2];
    
    [data  appendData:pwdata]; // 密码
    
    Byte chk = [self getCheck:[data subdataWithRange:NSMakeRange(1, data.length-1)]];
    [data appendBytes:&chk length:1];
    [[UdpHandler defaultUDP]sendData:data];
}

- (Byte)getCheck:(NSData*)data{
    // 把data所有字节累加
    Byte ret = 0x00;
    for (int i = 0 ; i < data.length; i++) {
        Byte b = 0x00;
        [data getBytes:&b range:NSMakeRange(i, 1)];
        ret += b;
    }
    return ret;
}


//- (IBAction)showhideBtnPressed:(id)sender {
//    [self.showhideBtn setSelected:!self.showhideBtn.isSelected];
//    if ([self.showhideBtn isSelected]) {
//        [self.showhideBtn setBackgroundImage:[UIImage imageNamed:@"showBtn"] forState:UIControlStateNormal];
//        [self.pwdTF setSecureTextEntry:NO];
//    }else{
//        [self.showhideBtn setBackgroundImage:[UIImage imageNamed:@"hideBtn"] forState:UIControlStateNormal];
//        [self.pwdTF setSecureTextEntry:YES];
//    }
//    
//}



- (IBAction)btnSetPortPressed:(UIButton *)sender {
    UIAlertView *dialog = [[UIAlertView alloc]initWithTitle:@"Set port" message:nil delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"Ok", nil];
    [dialog setAlertViewStyle:UIAlertViewStylePlainTextInput];
    UITextField *tf = [dialog textFieldAtIndex:0];
    [tf setKeyboardType:UIKeyboardTypeNumberPad];
    [tf setPlaceholder:@"Enter port(<65535)"];
    [tf setText:port];
    [dialog show];
}



-(void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    
    if (buttonIndex == 0) {
        return;
    }
    
    UITextField *tf = [alertView textFieldAtIndex:0];
    if ([self isStrEmpty:tf.text]) {
        [self showTipText:@"Invalid port"];
        return;
    }
    port = [tf.text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    [[NSUserDefaults standardUserDefaults]setObject:port forKey:@"port"];
    [[NSUserDefaults standardUserDefaults] synchronize];
}


- (IBAction)gotoSSIDList:(id)sender {
    
//    NSString *port = self.pottLb.text;
//    if ([self isStrEmpty:port]) {
//        [self shakeAction:self.pottLb];
//        return;
//    }
    
    [UdpHandler defaultUDP].targetPort  = [port intValue];
    
    
    UIStoryboard *sb = nil;
    if ([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone) {
        sb = [UIStoryboard storyboardWithName:@"Main_iPhone" bundle:nil];
    }else{
        sb = [UIStoryboard storyboardWithName:@"Main_iPad" bundle:nil];
    }
    SSIDListViewController *vc = (SSIDListViewController *)[sb instantiateViewControllerWithIdentifier:@"ssidVC"];
    vc.navigationItem.leftItemsSupplementBackButton = YES;
    [self.navigationController pushViewController:vc animated:YES];
}


- (void)analysisData:(NSData*)data{
    Byte cmd = 0x00;
    [data getBytes:&cmd range:NSMakeRange(3, 1)];
    if (cmd == 0x82) {
        //
        Byte ssidChk = 0x00;
        Byte pwdChk = 0x00;
        [data getBytes:&ssidChk range:NSMakeRange(4, 1)];
        [data getBytes:&pwdChk range:NSMakeRange(5, 1)];
        if (ssidChk == 0x00) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"Alert" message:@"Not find SSID" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
            [alert show];
        }else if (pwdChk == 0x00){
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"Alert" message:@"Password error" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
            [alert show];
        }
        if (ssidChk == 0x01 && pwdChk == 0x01) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"Alert" message:@"Send success" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
            [alert show];
        }
    }
}


#pragma mark - UdpHandlerDelegate

- (void)udpReceivedData:(NSData*)data fromAddress:(NSData *)address{
    [self analysisData:data];
}


- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [super touchesBegan:touches withEvent:event];
    [self.ssidTF resignFirstResponder];
    [self.pwdTF resignFirstResponder];
}




-(BOOL)isStrEmpty:(NSString *)str{
    if (nil == str) {//是否为空
        return true;
    }else if([str stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]].length == 0){//去掉左右两边空格
        return true;
    }
    return false;
}

- (void) shakeAction:(UIView *) shakeView{
    //晃动次数
    int numberOfShakes = 4;
    //晃动的幅度（相对于总宽带）
    float vigourOfShake = 0.04f;
    //动画持续时间
    float duration = 0.5f;
    
    
    CAKeyframeAnimation *shakeAnimation = [CAKeyframeAnimation animationWithKeyPath:@"position"];
    //绘制路径
    CGRect frame = shakeView.frame;
    //创建路径
    CGMutablePathRef shakePath = CGPathCreateMutable();
    //起始点
    CGPathMoveToPoint(shakePath, NULL, CGRectGetMidX(frame), CGRectGetMidY(frame));
    
    
    for (int i=0; i<numberOfShakes; i++) {
        //添加晃动路径，幅度由大变小
        CGPathAddLineToPoint(shakePath, NULL, CGRectGetMidX(frame) - frame.size.width * vigourOfShake*(1-(float)i/numberOfShakes),CGRectGetMidY(frame));
        CGPathAddLineToPoint(shakePath, NULL,CGRectGetMidX(frame) + frame.size.width * vigourOfShake*(1-(float)i/numberOfShakes),CGRectGetMidY(frame));
    }
    
    
    //闭合路径
    
    CGPathCloseSubpath(shakePath);
    shakeAnimation.path = shakePath;
    shakeAnimation.duration = duration;
    CFRelease(shakePath);
    [shakeView.layer addAnimation:shakeAnimation forKey:kCATransition];
}



- (void)showTipText:(NSString*)msg{
    MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:self.view animated:YES];
    // Configure for text only and offset down
    hud.mode = MBProgressHUDModeText;
    hud.labelText = msg;
    //    hud.margin = 10.f;
    //    hud.yOffset = 0.f;
    //    hud.labelFont = [UIFont systemFontOfSize:22];
    hud.removeFromSuperViewOnHide = YES;
    [hud hide:YES afterDelay:1.5];
    
}


@end
