//
//  SSIDListViewController.m
//  LinkRouter
//
//  Created by USRCN on 14-7-4.
//  Copyright (c) 2014年 usrcn. All rights reserved.
//

#import "SSIDListViewController.h"
#import "MainViewController.h"

@interface SSIDListViewController ()
{
    NSMutableArray * _ssidArr;
    NSMutableArray * _signalArr;//0-100
}

@end

@implementation SSIDListViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self.tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"ssidcell"];
    // Do any additional setup after loading the view.
    [[UdpHandler defaultUDP]setDelegate:self];
    [[UdpHandler defaultUDP]getSSIDList];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (BOOL)checkValidityWithData:(NSData*)data{
    NSData *concernedData = [data subdataWithRange:NSMakeRange(1, [data length]-2)];
    Byte sum = 0x00;
    Byte temp = 0;
    for (int i = 0; i < [concernedData length]; i++) {
        temp = 0;
        [concernedData getBytes:&temp range:NSMakeRange(i, 1)];
        sum += temp;
    }
    Byte checkNum = 0;
    [data getBytes:&checkNum range:NSMakeRange(data.length-1, 1)];
    if (sum == checkNum) {
        return YES;
    }
    return NO;
}


- (void)analysisData:(NSData*)data{
    // 验证
    unsigned b0 = 0;
    [data getBytes:&b0 range:NSMakeRange(0, 1)];
    if (b0 != 0xff) {
        return;
    }
    // 模拟器 调试错误，临时处理
    NSData *ddd = [NSData dataWithData:data];
    BOOL validity = [self checkValidityWithData:ddd];
    if (!validity) {
        NSLog(@"data is invalid!");
        return;
    }

    // 解析
    Byte cmdByte = 0;
    [data getBytes:&cmdByte range:NSMakeRange(3, 1)];
    if (cmdByte == 0x81) {
        //列表
        if (!_ssidArr) {
            _ssidArr = [[NSMutableArray alloc]init];
        }else {
            [_ssidArr removeAllObjects];
        }
        
        if (!_signalArr) {
            _signalArr = [[NSMutableArray alloc]init];
        }else {
            [_signalArr removeAllObjects];
        }
        int countssid = 0;
        [data getBytes:&countssid range:NSMakeRange(4, 1)];
        NSData *arrData = [data subdataWithRange:NSMakeRange(5, data.length-6)];
        int mark = 0;
        for (int i = 0; i < arrData.length-1; i++) {
            @try{
                Byte b1 = 0x00;
                Byte b2 = 0x00;
                [arrData getBytes:&b1 range:NSMakeRange(i, 1)];
                [arrData getBytes:&b2 range:NSMakeRange(i+1, 1)];
                if (b1 == 0x0d && b2 == 0x0a) {
                    NSData *ssid = [arrData subdataWithRange:NSMakeRange(mark, i-2-mark)];
                    int signal = 0;
                    [arrData getBytes:&signal range:NSMakeRange(i-1, 1)];
                    
                    
                    NSMutableString *ssidString = [[NSMutableString alloc]initWithData:ssid encoding:NSUTF8StringEncoding];
                    NSLog(@"ssid--------->%@",ssid);
                    NSLog(@"ssidStr--------->%@",ssidString);
                    [_ssidArr addObject:ssidString];
                    [_signalArr addObject:[NSNumber numberWithInt:signal]];
                    mark = i+2;
                    
                }
            }@catch(NSException *ex){
                NSLog(@"Exception------>%@",ex);
                mark = i+2;
            }
        }
        
        [self.tableView reloadData];
        
    }
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _ssidArr.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    //UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"ssidcell" forIndexPath:indexPath];
     UITableViewCell * cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"ssidcell"];
    [cell.textLabel setText:_ssidArr[indexPath.row]];
    NSNumber *number = _signalArr[indexPath.row];
    [cell.detailTextLabel setText:[NSString stringWithFormat:@"%i",number.intValue]];
    
    return cell;
}

#pragma mark - UItableview delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    MainViewController * vc = [self.navigationController viewControllers][0];
    [vc.ssidTF setText:[_ssidArr objectAtIndex:indexPath.row]];
    [self.navigationController popToRootViewControllerAnimated:YES];
}


#pragma mark - UdpHandlerDelegate

- (void)udpReceivedData:(NSData*)data fromAddress:(NSData *)address{
    [self analysisData:data];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
